#pragma once

#include <RobotAPI/libraries/core/Trajectory.h>

#include "Side.h"
#include <simox/control/impl/simox/robot/Robot.h>
#include <simox/example/method/PointingIK.h>

namespace armarx::control::pointing::core
{

    class PointingIK
    {
    public:
        PointingIK(VirtualRobot::RobotPtr robot, Side side);
        TrajectoryPtr computeTrajectory(Eigen::Vector3f& target);

    private:
        std::unique_ptr<simox::control::simox::robot::Robot> reducedRobot_;
        std::unique_ptr<simox::control::method::example::PointingIK> ik_;
    };

} // namespace armarx::control::pointing::core
