#pragma once

#include <RobotAPI/libraries/skills/provider/SimpleSpecializedSkill.h>
#include <armarx/control/retrieve_hand/core/RetrieveHand.h>
#include <armarx/control/retrieve_hand/aron/RetrieveHandParams.aron.generated.h>


namespace armarx::control::retrieve_hand::skills
{

    /**
    * @class RetrieveHand
    * @ingroup Library-retrieve_hand
    * @brief Brief description of class retrieve_hand.
    *
    * Detailed description of class retrieve_hand.
    */
    class RetrieveHand : public ::armarx::skills::SimpleSpecializedSkill<RetrieveHandParams>
    {
    public:
        using Base = ::armarx::skills::SimpleSpecializedSkill<RetrieveHandParams>;
        static ::armarx::skills::SkillDescription GetSkillDescription();
        struct Remote
        {
            // armarx::viz::Client arviz;
            armarx::armem::client::MemoryNameSystem memoryNameSystem;

            armarx::RobotUnitInterfacePrx robotUnit;
        };

        struct Properties
        {
            std::string robotName;
            // std::string robotNodeSet;
            // std::optional<armarx::ObjectID> objectId = std::nullopt;
        };

        RetrieveHand(const Remote& r);

        struct Subskills
        {
            std::function<bool(const Eigen::Vector3f&)> lookAt;
            std::function<bool()> openHand;
            std::function<bool()> closeHand;
        };

    public:
        RetrieveHand();

        // SpecializedSkill interface
        // Enable each function you want to override.
        // ::armarx::skills::Skill::InitResult init(const SpecializedInitInput&) override;
        ::armarx::skills::Skill::MainResult main(const SpecializedMainInput& in) override;

        void onStopRequested() override;

    private:
        Remote remote;
        Properties properties;
        // ::armarx::skills::Skill::ExitResult exit(const SpecializedExitInput&) override;

        std::unique_ptr<armarx::control::retrieve_hand::core::RetrieveHand> impl;

    };

}
