#pragma once

#include <string>

#include <RobotAPI/interface/units/HandUnitInterface.h>
#include <RobotAPI/interface/units/KinematicUnitInterface.h>

#include <armarx/control/skills/aron/HandParam.aron.generated.h>

namespace armarx::control::skills
{
    struct KinematicUnitService
    {
        ::armarx::KinematicUnitInterfacePrx kinematicUnit;
    };

    struct HandUnitServices
    {
        ::armarx::HandUnitInterfacePrx& leftHandUnit;
        ::armarx::HandUnitInterfacePrx& rightHandUnit;

        ::armarx::HandUnitInterfacePrx&
        getHandUnit(const arondto::Hand hand)
        {
            if (hand == arondto::Hand::Left)
            {
                return leftHandUnit;
            }
            else // hand == arondto::Hand::Right
            {
                return rightHandUnit;
            }
        }
    };

} // namespace armarx::control::skills
