#include "RelaxHand.h"

namespace armarx::control::skills::skills
{
    RelaxHand::RelaxHand(const HandUnitServices& srv) :
        ::armarx::skills::SimpleSpecializedSkill<ParamType>(GetSkillDescription()), srv_(srv)
    {
    }

    armarx::skills::Skill::MainResult
    RelaxHand::main(const SpecializedMainInput& in)
    {
        HandUnitInterfacePrx& handUnit = srv_.getHandUnit(in.parameters.hand);

        ARMARX_INFO << "Setting shape of hand '" << handUnit->getHandName() << "' to 'Relax'.";
        handUnit->setShape("Relax");
        return MakeSucceededResult();
    }

} // namespace armarx::control::skills::skills
