#pragma once

#include <experimental/memory>

#include <VirtualRobot/VirtualRobot.h>

#include <RobotAPI/interface/units/RobotUnit/NjointZeroTorqueController.h>
#include <RobotAPI/libraries/RobotAPIComponentPlugins/RobotUnitComponentPlugin.h>
#include <RobotAPI/libraries/skills/provider/SimpleSpecializedSkill.h>

#include <armarx/control/skills/aron/ZeroTorque.aron.generated.h>

namespace armarx::control::skills::skills
{

    class ZeroTorque :
        public ::armarx::skills::SimpleSpecializedSkill<armarx::control::skills::params::ZeroTorque>
    {

    public:
        struct Context
        {

            VirtualRobot::RobotPtr localRobot_;
            std::experimental::observer_ptr<armarx::plugins::RobotUnitComponentPlugin>
                robotUnitPlugin_;
        };

        static ::armarx::skills::SkillDescription GetSkillDescription();

        ZeroTorque(const config::ZeroTorque&);

        void connectTo(const Context& context);


    protected:
        MainResult main(const SpecializedMainInput& in) override;

        InitResult init(const SpecializedInitInput& in) override;

        ExitResult exit(const SpecializedExitInput& in) override;

    private:
        Context context_;
        config::ZeroTorque config_;
        armarx::NJointZeroTorqueControllerInterfacePrx controller_;
        std::string controllerName_;
    };

} // namespace armarx::control::skills::skills
